在CAD建模中,构建闭合的Wire(线框)是拓扑结构生成的基础操作。OpenCascade(OCCT)作为强大的几何建模库,支持从离散的Edge(边)构建Wire,但在实际应用中,边的有序性直接影响构建的成功率。本文将详细探讨有序与无序两种场景下的实现方法,并提供完整代码示例。
一、有序Edge构建闭合Wire
核心原理
当所有Edge按首尾相连的顺序排列时,直接使用BRepBuilderAPI_MakeWire
依次添加边即可自动形成闭合Wire。
代码实现
#include <gp_Pnt.hxx>
#include <TopoDS_Edge.hxx>
#include <TopoDS_Wire.hxx>
#include <BRepBuilderAPI_MakeEdge.hxx>
#include <BRepBuilderAPI_MakeWire.hxx>
#include <vector>
#include <cmath>
int main() {
const double radius = 10.0;
const int numPoints = 36;
const double deltaTheta = 2 * M_PI / numPoints;
// 生成离散点(包含闭合点)
std::vector<gp_Pnt> points;
for (int i = 0; i <= numPoints; ++i) {
double theta = i * deltaTheta;
points.emplace_back(radius * cos(theta), radius * sin(theta), 0.0);
}
// 按顺序创建边并构建Wire
BRepBuilderAPI_MakeWire wireMaker;
for (int i = 0; i < numPoints; ++i) {
TopoDS_Edge edge = BRepBuilderAPI_MakeEdge(points[i], points[i + 1]);
wireMaker.Add(edge);
}
if (wireMaker.IsDone()) {
TopoDS_Wire wire = wireMaker.Wire<